package com.gic.haoban.manage.service.service;

import com.gic.haoban.manage.api.dto.ExternalClerkRelatedDTO;
import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;

import java.util.Collection;
import java.util.List;

public interface ExternalClerkRelatedService {

	void insert(TabHaobanExternalClerkRelated related);

	/**
	 * 删除好友
	 * @param dto
	 */
	void delByUserIdAndExternalUserId(MemberUnionidRelatedDTO dto);

	/**
	 * 删除会员与导购的关联关系
	 *
	 * @param wxEnterpriseId
	 * @param wxUserId
	 * @param externalUserids
	 */
	void delByUserIdAndExternalUserIdBatch(String wxEnterpriseId, String staffId, List<String> externalUserids);

	void delByClerkIdAndStaffId(String clerkId, String staffId);

    void delByStoreIdAndStaffId(String storeId, String staffId);

	void delByStoreIds(Collection<String> storeIds);

	void cleanStaffRelated(String wxEnterpriseId, List<String> staffIds);

	void update(TabHaobanExternalClerkRelated exsitDTO);

	TabHaobanExternalClerkRelated getByParams(String staffId, String wxEnterpriseId, String name, String createTime);

	List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserId(String externalUserid, String wxUserId);

	List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserIdAllStatus(String wxEnterpriseId, String externalUserid, String wxUserId);

	ExternalClerkRelatedDTO getByMemberId(String staffId, String memberId);

	/**
	 * 根据unionid获取外部联系人的绑定导购
	 *
	 * @param enterpriseId
	 * @param unionId
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listExternalByUnionId(String enterpriseId, String unionId);

	/**
	 * 根据externalUserid获取外部联系人的绑定导购
	 *
	 * @param wxEnterpriseId
	 * @param externalUserid
	 * @return
	 */
	List<TabHaobanExternalClerkRelated> listExternalByExternalUserid(String wxEnterpriseId, String externalUserid);

	/**
	 * 校验会员id与unionid的对应 主要修复会员合并是没有更新会老的情况
	 *
	 * @param memberId
	 * @param unionId
	 * @return
	 */
	String checkAndUpdateMemberByUnonId(String enterpriseId, String memberId, String unionId);

}
